<template>
	<xn-form-container
		:title="formData.id ? '编辑旧版会员' : '增加旧版会员'"
		:width="700"
		v-model:open="open"
		:destroy-on-close="true"
		@close="onClose"
	>
		<a-form ref="formRef" :model="formData" :rules="formRules" layout="vertical">
			<a-form-item label="手机号：" name="phone">
				<a-input v-model:value="formData.phone" placeholder="请输入手机号" allow-clear />
			</a-form-item>
			<a-form-item label="姓名：" name="name">
				<a-input v-model:value="formData.name" placeholder="请输入姓名" allow-clear />
			</a-form-item>
			<a-form-item label="余额：" name="balance">
				<a-input v-model:value="formData.balance" placeholder="请输入余额" allow-clear />
			</a-form-item>
			<a-form-item label="卡类型：" name="cardType">
				<a-input v-model:value="formData.cardType" placeholder="请输入卡类型" allow-clear />
			</a-form-item>
			<a-form-item label="注册时间：" name="cardTime">
				<a-input v-model:value="formData.cardTime" placeholder="请输入注册时间" allow-clear />
			</a-form-item>
			<a-form-item label="说明：" name="memo">
				<a-input v-model:value="formData.memo" placeholder="请输入说明" allow-clear />
			</a-form-item>
		</a-form>
		<template #footer>
			<a-button style="margin-right: 8px" @click="onClose">关闭</a-button>
			<a-button type="primary" @click="onSubmit" :loading="submitLoading">保存</a-button>
		</template>
	</xn-form-container>
</template>

<script setup name="bizVipOldForm">
	import { cloneDeep } from 'lodash-es'
	import { required } from '@/utils/formRules'
	import bizVipOldApi from '@/api/biz/bizVipOldApi'
	// 抽屉状态
	const open = ref(false)
	const emit = defineEmits({ successful: null })
	const formRef = ref()
	// 表单数据
	const formData = ref({})
	const submitLoading = ref(false)

	// 打开抽屉
	const onOpen = (record) => {
		open.value = true
		if (record) {
			let recordData = cloneDeep(record)
			formData.value = Object.assign({}, recordData)
		}
	}
	// 关闭抽屉
	const onClose = () => {
		formRef.value.resetFields()
		formData.value = {}
		open.value = false
	}
	// 默认要校验的
	const formRules = {
	}
	// 验证并提交数据
	const onSubmit = () => {
		formRef.value
			.validate()
			.then(() => {
				submitLoading.value = true
				const formDataParam = cloneDeep(formData.value)
				bizVipOldApi
					.bizVipOldSubmitForm(formDataParam, formDataParam.id)
					.then(() => {
						onClose()
						emit('successful')
					})
					.finally(() => {
						submitLoading.value = false
					})
			})
			.catch(() => {})
	}
	// 抛出函数
	defineExpose({
		onOpen
	})
</script>
